Package com.saxonica.ee.stream.adjunct

## Class RootExpressionAdjunct

- java.lang.Object
- - com.saxonica.ee.stream.adjunct.StreamingAdjunct
  - - com.saxonica.ee.stream.adjunct.RootExpressionAdjunct

-     public class RootExpressionAdjunct
      extends StreamingAdjunct

  Streaming code for an expression that does not support streaming

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `RootExpressionAdjunct()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PostureAndSweep` | `computeStreamability​(ContextItemStaticInfoEE contextInfo, java.util.List<java.lang.String> reasons)` | Get the posture and sweep of this expression as defined in the W3C streamability specifications.
    `WatchMaker` | `getWatchMaker​(boolean forGrouping)` | Get a WatchMaker, a factory class that creates a Watch to evaluate this expression in streaming mode.
    `Pattern` | `toStreamingPattern​(Configuration config)` | Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.StreamingAdjunct

      `findConsumingArg, getConfiguration, getDefaultFeedMaker, getExpression, getFeedMaker, makeStreamingAdjunct, setConfiguration, setExpression`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RootExpressionAdjunct

          public RootExpressionAdjunct()

  - ### Method Detail

    - #### toStreamingPattern

          public Pattern toStreamingPattern​(Configuration config)

      Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)
      Overrides:
        `toStreamingPattern` in class `StreamingAdjunct`
      Parameters:
        `config` - the Saxon configuration
      Returns:
        the equivalent pattern if conversion succeeds; otherwise null

    - #### computeStreamability

          public PostureAndSweep computeStreamability​(ContextItemStaticInfoEE contextInfo,
                                                      java.util.List<java.lang.String> reasons)

      Get the posture and sweep of this expression as defined in the W3C streamability specifications. This provides an assessment of stylesheet code against the W3C criteria for guaranteed streamability, and is implemented to allow these criteria to be tested. It is not the case that all expression that emerge as streamable from this analysis are currently capable of being streamed by Saxon
      Overrides:
        `computeStreamability` in class `StreamingAdjunct`
      Parameters:
        `contextInfo` - Information about the context item for the expression
        `reasons` - the caller may supply a list, in which case the implementation may add to this
      Returns:
        the posture and sweep of the expression

    - #### getWatchMaker

          public WatchMaker getWatchMaker​(boolean forGrouping)
                                   throws XPathException

      Get a WatchMaker, a factory class that creates a Watch to evaluate this expression in streaming mode. This method will only be called if the getImplementationMethod() method of the expression includes the value `Expression.WATCH_METHOD`
      Overrides:
        `getWatchMaker` in class `StreamingAdjunct`
      Parameters:
        `forGrouping` -
      Returns:
        a Watchmaker to evaluate the expression, or null if it is not streamable with respect to the specificed argument.
      Throws:
        `XPathException` - in the event of a failure